/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.repository.impl;

import edu.kit.ipd.descartes.mm.applicationlevel.repository.ComposedStructure;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.InterfaceRequiringRole;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.RequiringDelegationConnector;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EcoreUtil;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Requiring Delegation Connector</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.impl.RequiringDelegationConnectorImpl#getParentStructure <em>Parent Structure</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.impl.RequiringDelegationConnectorImpl#getInnerInterfaceRequiringRole <em>Inner Interface Requiring Role</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.impl.RequiringDelegationConnectorImpl#getOuterInterfaceRequiringRole <em>Outer Interface Requiring Role</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class RequiringDelegationConnectorImpl extends DelegationConnectorImpl implements RequiringDelegationConnector {
	/**
	 * The cached value of the '{@link #getInnerInterfaceRequiringRole() <em>Inner Interface Requiring Role</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInnerInterfaceRequiringRole()
	 * @generated
	 * @ordered
	 */
	protected InterfaceRequiringRole innerInterfaceRequiringRole;

	/**
	 * The cached value of the '{@link #getOuterInterfaceRequiringRole() <em>Outer Interface Requiring Role</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOuterInterfaceRequiringRole()
	 * @generated
	 * @ordered
	 */
	protected InterfaceRequiringRole outerInterfaceRequiringRole;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RequiringDelegationConnectorImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RepositoryPackage.Literals.REQUIRING_DELEGATION_CONNECTOR;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposedStructure getParentStructure() {
		if (eContainerFeatureID() != RepositoryPackage.REQUIRING_DELEGATION_CONNECTOR__PARENT_STRUCTURE) return null;
		return (ComposedStructure)eInternalContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetParentStructure(ComposedStructure newParentStructure, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newParentStructure, RepositoryPackage.REQUIRING_DELEGATION_CONNECTOR__PARENT_STRUCTURE, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentStructure(ComposedStructure newParentStructure) {
		if (newParentStructure != eInternalContainer() || (eContainerFeatureID() != RepositoryPackage.REQUIRING_DELEGATION_CONNECTOR__PARENT_STRUCTURE && newParentStructure != null)) {
			if (EcoreUtil.isAncestor(this, newParentStructure))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newParentStructure != null)
				msgs = ((InternalEObject)newParentStructure).eInverseAdd(this, RepositoryPackage.COMPOSED_STRUCTURE__REQUIRING_DELEGATION_CONNECTORS, ComposedStructure.class, msgs);
			msgs = basicSetParentStructure(newParentStructure, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.REQUIRING_DELEGATION_CONNECTOR__PARENT_STRUCTURE, newParentStructure, newParentStructure));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InterfaceRequiringRole getInnerInterfaceRequiringRole() {
		if (innerInterfaceRequiringRole != null && innerInterfaceRequiringRole.eIsProxy()) {
			InternalEObject oldInnerInterfaceRequiringRole = (InternalEObject)innerInterfaceRequiringRole;
			innerInterfaceRequiringRole = (InterfaceRequiringRole)eResolveProxy(oldInnerInterfaceRequiringRole);
			if (innerInterfaceRequiringRole != oldInnerInterfaceRequiringRole) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RepositoryPackage.REQUIRING_DELEGATION_CONNECTOR__INNER_INTERFACE_REQUIRING_ROLE, oldInnerInterfaceRequiringRole, innerInterfaceRequiringRole));
			}
		}
		return innerInterfaceRequiringRole;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InterfaceRequiringRole basicGetInnerInterfaceRequiringRole() {
		return innerInterfaceRequiringRole;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInnerInterfaceRequiringRole(InterfaceRequiringRole newInnerInterfaceRequiringRole) {
		InterfaceRequiringRole oldInnerInterfaceRequiringRole = innerInterfaceRequiringRole;
		innerInterfaceRequiringRole = newInnerInterfaceRequiringRole;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.REQUIRING_DELEGATION_CONNECTOR__INNER_INTERFACE_REQUIRING_ROLE, oldInnerInterfaceRequiringRole, innerInterfaceRequiringRole));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InterfaceRequiringRole getOuterInterfaceRequiringRole() {
		if (outerInterfaceRequiringRole != null && outerInterfaceRequiringRole.eIsProxy()) {
			InternalEObject oldOuterInterfaceRequiringRole = (InternalEObject)outerInterfaceRequiringRole;
			outerInterfaceRequiringRole = (InterfaceRequiringRole)eResolveProxy(oldOuterInterfaceRequiringRole);
			if (outerInterfaceRequiringRole != oldOuterInterfaceRequiringRole) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RepositoryPackage.REQUIRING_DELEGATION_CONNECTOR__OUTER_INTERFACE_REQUIRING_ROLE, oldOuterInterfaceRequiringRole, outerInterfaceRequiringRole));
			}
		}
		return outerInterfaceRequiringRole;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InterfaceRequiringRole basicGetOuterInterfaceRequiringRole() {
		return outerInterfaceRequiringRole;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setOuterInterfaceRequiringRole(InterfaceRequiringRole newOuterInterfaceRequiringRole) {
		InterfaceRequiringRole oldOuterInterfaceRequiringRole = outerInterfaceRequiringRole;
		outerInterfaceRequiringRole = newOuterInterfaceRequiringRole;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.REQUIRING_DELEGATION_CONNECTOR__OUTER_INTERFACE_REQUIRING_ROLE, oldOuterInterfaceRequiringRole, outerInterfaceRequiringRole));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case RepositoryPackage.REQUIRING_DELEGATION_CONNECTOR__PARENT_STRUCTURE:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetParentStructure((ComposedStructure)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case RepositoryPackage.REQUIRING_DELEGATION_CONNECTOR__PARENT_STRUCTURE:
				return basicSetParentStructure(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case RepositoryPackage.REQUIRING_DELEGATION_CONNECTOR__PARENT_STRUCTURE:
				return eInternalContainer().eInverseRemove(this, RepositoryPackage.COMPOSED_STRUCTURE__REQUIRING_DELEGATION_CONNECTORS, ComposedStructure.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case RepositoryPackage.REQUIRING_DELEGATION_CONNECTOR__PARENT_STRUCTURE:
				return getParentStructure();
			case RepositoryPackage.REQUIRING_DELEGATION_CONNECTOR__INNER_INTERFACE_REQUIRING_ROLE:
				if (resolve) return getInnerInterfaceRequiringRole();
				return basicGetInnerInterfaceRequiringRole();
			case RepositoryPackage.REQUIRING_DELEGATION_CONNECTOR__OUTER_INTERFACE_REQUIRING_ROLE:
				if (resolve) return getOuterInterfaceRequiringRole();
				return basicGetOuterInterfaceRequiringRole();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case RepositoryPackage.REQUIRING_DELEGATION_CONNECTOR__PARENT_STRUCTURE:
				setParentStructure((ComposedStructure)newValue);
				return;
			case RepositoryPackage.REQUIRING_DELEGATION_CONNECTOR__INNER_INTERFACE_REQUIRING_ROLE:
				setInnerInterfaceRequiringRole((InterfaceRequiringRole)newValue);
				return;
			case RepositoryPackage.REQUIRING_DELEGATION_CONNECTOR__OUTER_INTERFACE_REQUIRING_ROLE:
				setOuterInterfaceRequiringRole((InterfaceRequiringRole)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case RepositoryPackage.REQUIRING_DELEGATION_CONNECTOR__PARENT_STRUCTURE:
				setParentStructure((ComposedStructure)null);
				return;
			case RepositoryPackage.REQUIRING_DELEGATION_CONNECTOR__INNER_INTERFACE_REQUIRING_ROLE:
				setInnerInterfaceRequiringRole((InterfaceRequiringRole)null);
				return;
			case RepositoryPackage.REQUIRING_DELEGATION_CONNECTOR__OUTER_INTERFACE_REQUIRING_ROLE:
				setOuterInterfaceRequiringRole((InterfaceRequiringRole)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case RepositoryPackage.REQUIRING_DELEGATION_CONNECTOR__PARENT_STRUCTURE:
				return getParentStructure() != null;
			case RepositoryPackage.REQUIRING_DELEGATION_CONNECTOR__INNER_INTERFACE_REQUIRING_ROLE:
				return innerInterfaceRequiringRole != null;
			case RepositoryPackage.REQUIRING_DELEGATION_CONNECTOR__OUTER_INTERFACE_REQUIRING_ROLE:
				return outerInterfaceRequiringRole != null;
		}
		return super.eIsSet(featureID);
	}

} //RequiringDelegationConnectorImpl
