/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.runtimeenvironmentclasses;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Runtime Environment Classes</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * <!-- begin-model-doc -->
 * This enumeration lists the possible classes of the containment hierarchy. The type NATIVE HARDWARE has been omitted because there is a meta model entity of this type.
 * <!-- end-model-doc -->
 * @see edu.kit.ipd.descartes.mm.runtimeenvironmentclasses.RuntimeenvironmentclassesPackage#getRuntimeEnvironmentClasses()
 * @model
 * @generated
 */
public enum RuntimeEnvironmentClasses implements Enumerator {
	/**
     * The '<em><b>HYPERVISOR</b></em>' literal object.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #HYPERVISOR_VALUE
     * @generated
     * @ordered
     */
	HYPERVISOR(1, "HYPERVISOR", "HYPERVISOR"),

	/**
     * The '<em><b>OPERATING SYSTEM</b></em>' literal object.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #OPERATING_SYSTEM_VALUE
     * @generated
     * @ordered
     */
	OPERATING_SYSTEM(2, "OPERATING_SYSTEM", "OPERATING SYSTEM"),

	/**
     * The '<em><b>OS VM</b></em>' literal object.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #OS_VM_VALUE
     * @generated
     * @ordered
     */
	OS_VM(3, "OS_VM", "OS VM"),

	/**
     * The '<em><b>PROCESS VM</b></em>' literal object.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #PROCESS_VM_VALUE
     * @generated
     * @ordered
     */
	PROCESS_VM(4, "PROCESS_VM", "PROCESS VM"),

	/**
     * The '<em><b>MIDDLEWARE</b></em>' literal object.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #MIDDLEWARE_VALUE
     * @generated
     * @ordered
     */
	MIDDLEWARE(5, "MIDDLEWARE", "MIDDLEWARE"),

	/**
     * The '<em><b>OTHER</b></em>' literal object.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #OTHER_VALUE
     * @generated
     * @ordered
     */
	OTHER(6, "OTHER", "OTHER");

	/**
     * The '<em><b>HYPERVISOR</b></em>' literal value.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>HYPERVISOR</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @see #HYPERVISOR
     * @model
     * @generated
     * @ordered
     */
	public static final int HYPERVISOR_VALUE = 1;

	/**
     * The '<em><b>OPERATING SYSTEM</b></em>' literal value.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>OPERATING SYSTEM</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @see #OPERATING_SYSTEM
     * @model literal="OPERATING SYSTEM"
     * @generated
     * @ordered
     */
	public static final int OPERATING_SYSTEM_VALUE = 2;

	/**
     * The '<em><b>OS VM</b></em>' literal value.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>OS VM</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @see #OS_VM
     * @model literal="OS VM"
     * @generated
     * @ordered
     */
	public static final int OS_VM_VALUE = 3;

	/**
     * The '<em><b>PROCESS VM</b></em>' literal value.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>PROCESS VM</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @see #PROCESS_VM
     * @model literal="PROCESS VM"
     * @generated
     * @ordered
     */
	public static final int PROCESS_VM_VALUE = 4;

	/**
     * The '<em><b>MIDDLEWARE</b></em>' literal value.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>MIDDLEWARE</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @see #MIDDLEWARE
     * @model
     * @generated
     * @ordered
     */
	public static final int MIDDLEWARE_VALUE = 5;

	/**
     * The '<em><b>OTHER</b></em>' literal value.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>OTHER</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @see #OTHER
     * @model
     * @generated
     * @ordered
     */
	public static final int OTHER_VALUE = 6;

	/**
     * An array of all the '<em><b>Runtime Environment Classes</b></em>' enumerators.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private static final RuntimeEnvironmentClasses[] VALUES_ARRAY =
		new RuntimeEnvironmentClasses[] {
            HYPERVISOR,
            OPERATING_SYSTEM,
            OS_VM,
            PROCESS_VM,
            MIDDLEWARE,
            OTHER,
        };

	/**
     * A public read-only list of all the '<em><b>Runtime Environment Classes</b></em>' enumerators.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static final List<RuntimeEnvironmentClasses> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
     * Returns the '<em><b>Runtime Environment Classes</b></em>' literal with the specified literal value.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static RuntimeEnvironmentClasses get(String literal) {
        for (int i = 0; i < VALUES_ARRAY.length; ++i) {
            RuntimeEnvironmentClasses result = VALUES_ARRAY[i];
            if (result.toString().equals(literal)) {
                return result;
            }
        }
        return null;
    }

	/**
     * Returns the '<em><b>Runtime Environment Classes</b></em>' literal with the specified name.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static RuntimeEnvironmentClasses getByName(String name) {
        for (int i = 0; i < VALUES_ARRAY.length; ++i) {
            RuntimeEnvironmentClasses result = VALUES_ARRAY[i];
            if (result.getName().equals(name)) {
                return result;
            }
        }
        return null;
    }

	/**
     * Returns the '<em><b>Runtime Environment Classes</b></em>' literal with the specified integer value.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static RuntimeEnvironmentClasses get(int value) {
        switch (value) {
            case HYPERVISOR_VALUE: return HYPERVISOR;
            case OPERATING_SYSTEM_VALUE: return OPERATING_SYSTEM;
            case OS_VM_VALUE: return OS_VM;
            case PROCESS_VM_VALUE: return PROCESS_VM;
            case MIDDLEWARE_VALUE: return MIDDLEWARE;
            case OTHER_VALUE: return OTHER;
        }
        return null;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private final int value;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private final String name;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private final String literal;

	/**
     * Only this class can construct instances.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private RuntimeEnvironmentClasses(int value, String name, String literal) {
        this.value = value;
        this.name = name;
        this.literal = literal;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public int getValue() {
      return value;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public String getName() {
      return name;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public String getLiteral() {
      return literal;
    }

	/**
     * Returns the literal value of the enumerator, which is its string representation.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public String toString() {
        return literal;
    }
	
} //RuntimeEnvironmentClasses
