/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.perfdatarepo;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see edu.kit.ipd.descartes.perfdatarepo.PerfdatarepoPackage
 * @generated
 */
public interface PerfdatarepoFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	PerfdatarepoFactory eINSTANCE = edu.kit.ipd.descartes.perfdatarepo.impl.PerfdatarepoFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>Performance Data Repository</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Performance Data Repository</em>'.
	 * @generated
	 */
	PerformanceDataRepository createPerformanceDataRepository();

	/**
	 * Returns a new object of class '<em>Result</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Result</em>'.
	 * @generated
	 */
	Result createResult();

	/**
	 * Returns a new object of class '<em>Measured Entity</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Measured Entity</em>'.
	 * @generated
	 */
	MeasuredEntity createMeasuredEntity();

	/**
	 * Returns a new object of class '<em>Metric Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Metric Type</em>'.
	 * @generated
	 */
	MetricType createMetricType();

	/**
	 * Returns a new object of class '<em>Metric Value</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Metric Value</em>'.
	 * @generated
	 */
	MetricValue createMetricValue();

	/**
	 * Returns a new object of class '<em>Impact</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Impact</em>'.
	 * @generated
	 */
	Impact createImpact();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	PerfdatarepoPackage getPerfdatarepoPackage();

} //PerfdatarepoFactory
